clear all
clc
clf
fitabx_e14 % Vypocet odporu vlakna pri izbovej teplote
           % Subor 'fitabx_e14' vola funkciu 'linreg3'
           % Prvy vstupny datovy subor je oznaceny ako 'ui_1.dat'
clc
clf
R0 = a1    % Odpor vlakna pri teplote t = 0 stup. celzia
disp(' ');disp(' ')
[expdata,adr] = uigetfile('*.dat','Vyber vstupneho suboru'); % Vyber druheho datoveho suboru
                                                             % je oznaceny ako 'ui_2.dat' 
file=['data=load(expdata);'];% Otvorenie datoveho suboru 
eval(file);
disp(' Copyright (c) 2006 by L. Sevcovic, Kat. fyziky, FEI TU v Kosiciach')
disp(' ')
nazovgrf=input(' Napiste nazov grafu: ','s');
%
clf
u=eval('data(:,1)');
i=eval('data(:,2)');
%%
ydata=u.*i;
xdata=((u./i) + R0*(.0048*300 - 1))/(R0*.0048); % alfa = 0.0048 K^(-1)
%% 
start = [10^-4 10^-10 4]; % startovacie hodnoty parametrov p(1), p(2), p(3)
[p,chi2] = fminsearch(@stefboltz,start,[],xdata,ydata);
%%
Tfine = xdata(1):10:xdata(end);
yfine = p(1)*Tfine + p(2)*Tfine.^p(3);
fit = p(1)*xdata + p(2)*xdata.^p(3);
% chi2 = chi_squared(ydata,fit,3,1) % ina moznost vypoctu chi2
%%
h = axes('Position',[0 0 1 1],'Visible','off','FontSize',12);
axes('Position',[.3 .1 .65 .8],'FontSize',12)
shg
plt = plot(xdata,ydata,'s',Tfine,yfine,'-','MarkerSize',5,'Color',[0 0 0]);
title(['' num2str(nazovgrf) '']);
xlabel('Teplota vlakna (K)');
ylabel('Vyziareny vykon (W)');
rgx=abs(xdata(end)-xdata(1));rgy=abs(ydata(end)-ydata(1));% x-y range compute
xlim([xdata(1)-.05*rgx xdata(end)+.05*rgx]);
ylim([ydata(1)-.08*rgy ydata(end)+.08*rgy]);
set(plt(2),'color','red')
%%
str(1) = {'Regresna funkcia:'};
str(2) = {''};
str(3) = {'{\it y} = \beta_1{\it x} + \beta_2{\it x}^{ \lambda}'};
%str(4) = {'With the values:'};
str(5) = {[' \beta_1 =',sprintf('%8.3e ',p(1))]};
str(6) = {[' \beta_2 =',sprintf('%8.3e ',p(2))]};
str(7) = {[' \lambda =',sprintf('%8.3f ',p(3))]};
str(9) = {['{\it \chi}^2 =',sprintf('%8.4f ',chi2)]};
str(10) = {['{\it N-P} =',sprintf('%3.0f ',max(size(ydata))-max(size(p)))]};
set(gcf,'CurrentAxes',h);
text(.025,.6,str,'FontSize',12)
%%