% Copyright (c) 2006 by L. Sevcovic, Kat. fyziky, FEI TU v Kosiciach
clear all
clc
disp('Copyright (c) 2006 by L. Sevcovic, Kat. fyziky, FEI TU v Kosiciach')
disp(' ')
disp(' Priklad formatu suboru vstupnych dat, stlpce su oddelene klavesom TAB. Namerane')
disp(' hodnoty zapisujte v miliamperoch. Vytvoreny subor ulozte s koncovkou *.dat')
disp(' ')
disp('  50	4 ')
disp('  100	3.9 ')
disp('  150	3.8 ')
disp('  200	3.55 ')
disp('  250	3.15 ')
disp('  300	2.55 ')
disp('  350	1.95 ')
disp(' ')
%
disp(' ')
[expdata,adr] = uigetfile('*.dat','Vyber vstupneho suboru'); % Vyber suboru
file=['data=load(expdata);'];% Otvorenie suboru
eval(file);
nazovgrf=input(' Napiste nazov grafu: ','s');
nazovx=input(' Napiste nazov x-ovej osi (jednotku prudu nepiste): ','s');
nazovy=input(' Napiste nazov y-ovej osi (jednotku prudu nepiste): ','s');
disp(' ')
disp(' Ked chcete, do plochy grafov mozete vlozit vlastny text');
disp(' ako poznamku. Kurzor presunte na dane miesto a kliknite.');
info1=input(' Napiste text do prveho grafu: ','s');
info2=input(' Napiste text do druheho grafu: ','s');
clf
x=eval('data(:,1)');
y=eval('data(:,2)');
xb=eval('data(1,1)'); xe=eval('data(end,1)');
% Vypocty
xfine=xb:10:xe;% Vytvorenienie x-ovych hodnot na fitovanie 
               % s krokom 10mA (presnost nastavenia prudu I_m)
Efit=ppval(spline(x,y),xfine);% Hodnoty fitovania exper. dat kub. splajnom
Edydx=mmderiv(x,y);% Derivacia exper. dat (x,y) 
                   % funkciou mmderiv (Derivative Using Weighted Central Differences)
Edydxfit=interp1(x,Edydx,xfine,'*spline');% Fitovanie Edydx splajnom
% The 'interp1' and 'interp2' commands have special algorithms for fastier
% interpolation of equidistant data points. To usethis, one has to put an
% asterisk, '*', in front of the name of the method.
[min_der,md]=min(Edydxfit);% Urcenie minima krivky 1. derivacie
Im_min=xb+((xe-xb)/(length(xfine)-1))*(md-1);% Krit. prud z hod. minima krivky 1. derivacie   
%
shg
% subplot(2,1,1);% Vykreslenie exp. dat a fitovanie krivky kub. splajnom
axes1 = axes('Position',[.1 .55 .875 .435],'FontSize',12);%,'Parent',figure1);
box(axes1,'on');
hold(axes1,'all');
plot(x,y,'o',xfine,Efit,'r','Color',[0 0 0]);
scalex=((max(x)-min(x))*.1);
scaley=((max(y)-min(y))*.1);
xlim([min(x)-scalex max(x)+scalex]);
ylim([min(y)-scaley max(y)*1.1]);
title(['' num2str(nazovgrf) ''])
ylabel(['' num2str(nazovy) '' 'I_{A} (mA)']);
%
% subplot(2,1,2);% Vykreslenie derivacie exp. dat, ich fitovanie a vypis krit. prudu  
axes2 = axes('Position',[.1 .05 .875 .435],'FontSize',12);%,'Parent',figure1);
box(axes2,'on');
hold(axes2,'all');
plot(x,Edydx,'ks',xfine,Edydxfit,'-','Color',[0 0 0]);
scaley=((max(Edydx)-min(Edydx))*.1);
xlim([min(x)-scalex max(x)+scalex]);
ylim([min(Edydx)*1.1 max(Edydx)+scaley]);
text(Im_min,min_der,['\bf\downarrow      Kriticky prud I_{K}= ' num2str(Im_min) 'mA'],...
    'FontSize',8,'Color','k');
xlabel(['' num2str(nazovx) '' ' (mA)']);
ylabel('Prva derivcia I_{A}');
gtext(['\it' num2str(info1) ''],'FontSize',8);% Vpisanie textu do plochy prvrho grafu
gtext(['\it' num2str(info2) ''],'FontSize',8);% Vpisanie textu do plochy druheho grafu
%%