% Pre MATLAB 5.2
% Copyright (c) 2003 by L. Sevcovic, Kat. fyziky, FEI TU v Kosiciach
%
% Priklad formatu suboru vstupnych dat, stlpce su oddelene klavesom TAB.
% Namerane hodnoty zapisujte v miliamperoch.  Napr.
% 50	4 
% 100	3.9 
% 150	3.8 
% 200	3.55
% 250	3.15
% 300	2.55
% 350	1.95
% Vytvoreny subor s datami ulozte s koncovkou *.dat do priecinka, v ktorom sa nachadza
% tento subor. Spustite ho stlacenim klavesu F5. Po vybere suboru s datami
% sa prepnite do okna 'Command Window' programu MATLAB a pokracujte podla pokynov.
% 
clear all
clc
clf
disp(' ');disp(' ')
[expdata,adr] = uigetfile('*.dat','Vyber vstupneho suboru'); % Vyber datoveho suboru
file=['data=load(expdata);'];% Otvorenie datoveho suboru 
eval(file);
disp(' Copyright (c) 2006 by L. Sevcovic, Kat. fyziky, FEI TU v Kosiciach')
disp(' ')
nazovgrf=input(' Napiste nazov grafu: ','s');
nazovx=input(' Napiste nazov x-ovej osi (jednotku prudu nepiste): ','s');
nazovy=input(' Napiste nazov y-ovej osi (jednotku prudu nepiste): ','s');
disp(' ')
disp(' Ked chcete, do plochy grafov mozete vlozit vlastny text');
disp(' ako poznamku. Kurzor presunte na dane miesto a kliknite.');
info1=input(' Napiste text do prveho grafu: ','s');
info2=input(' Napiste text do druheho grafu: ','s');
clf
x=eval('data(:,1)');
y=eval('data(:,2)');
xb=eval('data(1,1)');% alebo xb=min(x)
xe=eval('data(end,1)');% alebo xe=max(x)
% Vypocty
xfine=xb:10:xe;% Vytvorenienie x-ovych hodnot na fitovanie (s krokom 10mA
               % t. j. s presnostou nastavenia prudu I_m)
Efit=ppval(spline(x,y),xfine);% Hodnoty fitovania exper. dat kub. splajnom
Edydx=mmderiv(x,y);% Derivacia exper. dat (x,y) funkciou 'mmderiv'
                   % (Derivative Using Weighted Central Differences)
Edydxfit=interp1(x,Edydx,xfine,'*spline');% Fitovanie Edydx splajnom
% The 'interp1' and 'interp2' commands have special algorithms for fastier
% interpolation of equidistant data points. To usethis, one has to put an
% asterisk, '*', in front of the name of the method.
[min_der,md]=min(Edydxfit);% Urcenie minima krivky 1. derivacie
Im_min=xb+((xe-xb)/(length(xfine)-1))*(md-1);% Krit. prud z hod. minima krivky 1. derivacie   
%
subplot(2,1,1);% Vykreslenie exp. dat a fit. krivky kub. splajnom
plot(x,y,'o',xfine,Efit,'r');
title(['' num2str(nazovgrf) ''])
scalex=((max(x)-min(x))*.1);
scaley=((max(y)-min(y))*.1);
xlim([min(x)-scalex max(x)+scalex]);
ylim([min(y)-scaley max(y)*1.1]);
ylabel(['' num2str(nazovy) '' 'I_{A} (mA)']);
%
subplot(2,1,2);% Vykreslenie der. exp. dat, ich fitovanie a vypis krit. prudu  
plot(x,Edydx,'ks',xfine,Edydxfit,'-');
text(Im_min,min_der,['\bf\downarrow      Kriticky prud I_{K}= ' num2str(Im_min) 'mA'],...
    'FontSize',8,'Color','k');
scalex=((max(x)-min(x))*.1);
scaley=((max(Edydx)-min(Edydx))*.1);
xlim([min(x)-scalex max(x)+scalex]);
ylim([min(Edydx)*1.1 max(Edydx)+scaley]);
xlabel(['' num2str(nazovx) '' ' (mA)']);
ylabel('Prva derivacia I_{A}');
gtext(['\it' num2str(info1) '']);% Vpisanie textu do plochy prvrho grafu
gtext(['\it' num2str(info2) '']);% Vpisanie textu do plochy druheho grafu
%%